(* cgContext.mli     Wrapper for CGBitmapContext
 *
 * Copyright (c) 2011 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)
type t = [`ubyte] Raw.t * nativeint

external create : int -> int -> t =
    "CGContext_create"

let getData (r,_ : t) = r

type linecap = LineCapButt | LineCapRound | LineCapSquare

external setLineCap : t -> linecap -> unit =
    "CGContext_setLineCap"
external  setLineWidth : t -> float -> unit =
    "CGContext_setLineWidth"
external addCurveToPoint : t -> Cocoa.point -> Cocoa.point -> Cocoa.point ->
            unit =
    "CGContext_addCurveToPoint"
external addLineToPoint : t -> Cocoa.point -> unit =
    "CGContext_addLineToPoint"
external beginPath : t -> unit =
    "CGContext_beginPath"
external closePath : t -> unit =
    "CGContext_closePath"
external moveToPoint : t -> Cocoa.point -> unit =
    "CGContext_moveToPoint"
external fillPath : t -> unit =
    "CGContext_fillPath"
external fillRect : t -> Cocoa.rect -> unit =
    "CGContext_fillRect"
external strokePath : t -> unit =
    "CGContext_strokePath"
external setFillColor : t -> Cocoa.color -> unit =
    "CGContext_setFillColor"
external setStrokeColor : t -> Cocoa.color -> unit =
    "CGContext_setStrokeColor"
external scaleCTM : t -> float -> float -> unit =
    "CGContext_scaleCTM"
external translateCTM : t -> float -> float -> unit =
    "CGContext_translateCTM"

type tdmode =
    Fill | Stroke | FillStroke | Invisible |
    FillClip | StrokeClip | FillStrokeClip | Clip
type atm = float * float * float * float * float * float

external getTextPosition : t -> Cocoa.point =
    "CGContext_getTextPosition"
external selectFont : t -> string -> float -> unit =
    "CGContext_selectFont"
external setTextDrawingMode : t -> tdmode -> unit =
    "CGContext_setTextDrawingMode"
external setTextMatrix : t -> atm -> unit =
    "CGContext_setTextMatrix"
external setTextPosition : t -> Cocoa.point -> unit =
    "CGContext_setTextPosition"
external showText : t -> string -> int -> unit =
    "CGContext_showText"
